<?php

ob_start('ob_gzhandler');
include('../../api/config.php');

date_default_timezone_set("Asia/Riyadh");
$TodayIs = date("Y-m-d H:i:s");

function haversineDistance($point1, $point2, $unit = 'kilometers') {
    // Extract latitude and longitude from the points
    list($lat1, $lon1) = $point1;
    list($lat2, $lon2) = $point2;

    // Convert latitude and longitude from degrees to radians
    $lat1 = deg2rad($lat1);
    $lon1 = deg2rad($lon1);
    $lat2 = deg2rad($lat2);
    $lon2 = deg2rad($lon2);

    // Calculate the change in coordinates
    $deltaLat = $lat2 - $lat1;
    $deltaLon = $lon2 - $lon1;

    // Haversine formula
    $a = sin($deltaLat / 2) * sin($deltaLat / 2) + cos($lat1) * cos($lat2) * sin($deltaLon / 2) * sin($deltaLon / 2);
    $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

    // Earth's radius in kilometers
    $earthRadius = 6371; // kilometers

    // Calculate the distance
    $distance = $earthRadius * $c;

    return $distance;
}

$resx88 = $mysqli->query("SELECT `ProjectID`,`AccurateLocation` FROM `project_locations` WHERE `AccurateLocation` IS NOT NULL");
$numrows1 = mysqli_num_rows($resx88);
if ($numrows1 > 0) {
    while ($row88 = $resx88->fetch_assoc()) {
        
      
        $AccurateLocation = str_replace('|', ',', $row88['AccurateLocation']);

        // Assuming AccurateLocation is stored as "latitude,longitude"
        $LocationArray = [16.93701,42.61592];
        $AccurateLocationArray = explode(',', $AccurateLocation);

        $distance = haversineDistance($LocationArray, $AccurateLocationArray);
        if($distance <= 14){
                    $return[$row88['ProjectID']]['ProjectID'] = $row88['ProjectID'];
                    $return[$row88['ProjectID']]['Rd0Location'] = $AccurateLocation;
                    $return[$row88['ProjectID']]['distance'] = $distance;
        }
    }
}

header('Content-Type: application/json');
echo json_encode($return);
?>
