<?php

ob_start('ob_gzhandler');
include('../../api/config.php');

$PerToken = $_POST['PerToken'];
$PerUserID = $_POST['PerUserID'];
$PerRoleID = $_POST['PerRoleID'];
$PStageID = $_POST['PStageID'];

$UserCheck = $mysqli->prepare("SELECT Token FROM `login_tokens` WHERE `UID` = ? AND `Token` = ? LIMIT 1");
$UserCheck->bind_param('ss', $PerUserID, $PerToken);
$UserCheck->execute();
$UserCheckResult = $UserCheck->get_result();
if ($UserCheckResult->num_rows == 0) {
    $return["error"] = true;
    $return["message"] = "Access denied!";
} else {
    if (isset($_FILES['File']) && $_FILES['File']['error'] == 0) {
        $file = $_FILES['File'];
        $filename = $file['name'];
        $tmp_name = $file['tmp_name'];
        
        // Generate a new unique filename
        $extension = pathinfo($filename, PATHINFO_EXTENSION);
        $Token = bin2hex(random_bytes(5));
        $newfilename = $Token . '_' . date('Y-m-d_H-i-s') . "." . $extension;
        
        $target_path = "../../uploads/inspection/" . $newfilename;

        if (move_uploaded_file($tmp_name, $target_path)) {
            // Fetch all entries that have the file in the JSON
            $selectQuery = $mysqli->prepare("SELECT `AnswerID`, `File` FROM `ins_answers` WHERE JSON_CONTAINS(`File`, JSON_OBJECT('File', ?)) AND `PStageID` = ?");
            $selectQuery->bind_param('si', $filename, $PStageID);
            $selectQuery->execute();
            $results = $selectQuery->get_result();

            $fileUsageCount = 0;
            $answersToUpdate = [];

            while ($row = $results->fetch_assoc()) {
                $files = json_decode($row['File'], true);
                foreach ($files as $index => $file) {
                    if ($file['File'] === $filename) {
                        $fileUsageCount++;
                        $answersToUpdate[] = ['AnswerID' => $row['AnswerID'], 'Files' => $files, 'Index' => $index];
                    }
                }
            }

            // Update database for all relevant entries
            $updatesMade = 0;
            foreach ($answersToUpdate as $answer) {
                // Update the filename and ensure Deleted is '0'
                $answer['Files'][$answer['Index']]['File'] = $newfilename; 
                $answer['Files'][$answer['Index']]['Deleted'] = '0';
                $updatedJson = json_encode($answer['Files']);
                
                $updateQuery = $mysqli->prepare("UPDATE `ins_answers` SET `File` = ? WHERE `AnswerID` = ?");
                $updateQuery->bind_param('si', $updatedJson, $answer['AnswerID']);
                $updateQuery->execute();
                $updatesMade += $updateQuery->affected_rows;
            }

            if ($updatesMade > 0) {
                $return["error"] = false;
                $return["message"] = "File names updated and deleted status set for files in stage $PStageID.";
                 error_log("File names updated and deleted status set for files in stage $PStageID.");
            } else {
                $return["error"] = false;
                $return["message"] = "No updates made. Files may not exist or already set as undeleted.";
                error_log( "No updates made. Files may not exist or already set as undeleted.");
            }
        } else {
            $return["error"] = true;
            $return["message"] = "Failed to move the uploaded file.";
            error_log("Failed to move the uploaded file.");
        }
    } else {
        $return["error"] = true;
        $return["message"] = "No file uploaded or file upload error.";
        error_log("No file uploaded or file upload error.");
    }
}

header('Content-Type: application/json');
echo json_encode($return);

?>
